function [x,xcost,info]= general_symm_correspondence_5(X,P,E)
    e=ones(size(X,2),1);
    d=size(X,1);
    elements = struct();
    elements.R = rotationsfactory(d, 1);
    elements.t = euclideanfactory(d, 1);
    manifold = productmanifold(elements);
    problem.M = manifold;
    problem.cost = @cost;
    function L=LB(A,B)
        L=A*B-B*A;
    end
    function f = cost(M)
        R=M.R;t=M.t;
        f = norm(R*E*R'*(X-t*e')-(X*P-t*e'),'fro')^2;
    end
    function G = egrad(M)
        R=M.R;
        t=M.t;
        X1=(X-t*e');Y1=(X*P-t*e');
        A=Y1*X1'+X1*Y1';
        G.R=-2*A*R*E;
        G.t=2*(eye(d)-R*E*R')*(2*size(X,2)*t-X*(e+P*e));
    end
    problem.egrad = @egrad;
    function G = grad(M)
        R=M.R;
        t=M.t;
        X1=(X-t*e');Y1=(X*P-t*e');
        A=Y1*X1'+X1*Y1';
        G.R=-R'*A*R*E+E*R'*A*R;
        G.t=2*(eye(d)-R*E*R')*(2*size(X,2)*t-X*(e+P*e));
    end
    problem.grad = @grad;
    function H = ehess(M,O)
        R=M.R; 
        t=M.t;
        U=(X-t*e');V=(X*P-t*e');
        A=U*V'+V*U';
        H.R=-2*A*R*O.R*E;
        H.t=4*(e'*e)*(eye(d)-R*E*R')*O.t;  
    end
    %problem.ehess = @ehess;
    function H = hess(M,O)
        R=M.R; 
        t=M.t;
        U=(X-t*e');V=(X*P-t*e');
        A=U*V'+V*U';
        H.R=0.5*(LB(R'*A*R,LB(E,O.R))+LB(E,LB(R'*A*R,O.R)));
        H.t=4*(e'*e)*(eye(d)-R*E*R')*O.t;  
    end
    %problem.hess = @hess;
    warning('off', 'manopt:getHessian:approx') 
    [x, xcost, info,~,~] = trustregions(problem);
end