#include "mex.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#define max1(a,b)(((a) > (b)) ? (a) : (b))
#define min1(a,b)(((a) < (b)) ? (a) : (b))
struct Point
{
    double x;
    double y;
    double z;
};
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
    #define pt1_OUT plhs[0]
    #define pt2_OUT plhs[1]
    #define ri_OUT plhs[2]
    #define X_IN prhs[0]
    #define E_IN prhs[1]
    #define n_IN prhs[2]
    
    int num_pts, num_dim;
    num_pts=mxGetM(X_IN);
    num_dim=mxGetN(X_IN);
    double *E,*X,*pt1,*pt2;
    double *nm;
    X=mxGetPr(X_IN);
    int gh,ch,pr;
    E=mxGetPr(E_IN);
    nm=mxGetPr(n_IN);
    int num_of_pairs=(int)*nm;
    double *loc_P1,*loc_P2;
    loc_P1=(double*)malloc(6* sizeof(double));
    loc_P2=(double*)malloc(6* sizeof(double));
    int cnt_g=0;
    double *ri;
    double th_t=0.03*3.14/180;
    ri_OUT=mxCreateDoubleMatrix(num_of_pairs*2,1,mxREAL);
    ri=mxGetPr(ri_OUT);
    for(pr=0;pr<num_of_pairs;pr++)
    {
        int r1,r2;
        r1=rand()%num_pts;
        r2=r1;
        while (r2==r1)
        {
            r2=rand()%num_pts; 
        }
        ri[2*pr+0]=r1+1;
        ri[2*pr+1]=r2+1;
        int pts1[num_pts-2][2];
        int pts2[num_pts-2][2];
        int cnt=0;
        int n,m;
        for (n=0;n<num_pts;n++)
        {   if(n!=r1&&n!=r2)
            {
                pts1[cnt][0]=r1;pts1[cnt][1]=n; 
                pts2[cnt][0]=r2;pts2[cnt][1]=n;
                cnt=cnt+1;
            }
        }
        for (n=0;n<num_pts-2;n++)
        {  
            struct Point P;
            struct Point Q;
            P.x=X[pts1[n][0]+0*(num_pts)];P.y=X[pts1[n][0]+1*(num_pts)];P.z=X[pts1[n][0]+2*(num_pts)];
            Q.x=X[pts1[n][1]+0*(num_pts)];Q.y=X[pts1[n][1]+1*(num_pts)];Q.z=X[pts1[n][1]+2*(num_pts)];
            struct Point M;
            M.x=(P.x+Q.x)*0.5;M.y=(P.y+Q.y)*0.5;M.z=(P.z+Q.z)*0.5;
            struct Point U;
            U.x=P.x-Q.x;U.y=P.y-Q.y;U.z=P.z-Q.z;
            double U_norm=1.0/pow(U.x*U.x+U.y*U.y+U.z*U.z,0.5);
            U.x=U.x*U_norm;U.y=U.y*U_norm;U.z=U.z*U_norm;
            double c0=-(U.x*M.x+U.y*M.y+U.z*M.z);
            for ( m=0;m<num_pts-2;m++)
            {
                struct Point P1;
                struct Point Q1;
                P1.x=X[pts2[m][0]+0*(num_pts)];P1.y=X[pts2[m][0]+1*(num_pts)];P1.z=X[pts2[m][0]+2*(num_pts)];
                Q1.x=X[pts2[m][1]+0*(num_pts)];Q1.y=X[pts2[m][1]+1*(num_pts)];Q1.z=X[pts2[m][1]+2*(num_pts)];
                double d1,d2;
                d1=fabs(U.x*P1.x+U.y*P1.y+U.z*P1.z+c0);
                d2=fabs(U.x*Q1.x+U.y*Q1.y+U.z*Q1.z+c0);
                struct Point V;
                V.x=P1.x-Q1.x;V.y=P1.y-Q1.y;V.z=P1.z-Q1.z;
                double V_norm=1.0/pow(V.x*V.x+V.y*V.y+V.z*V.z,0.5);
                V.x=V.x*V_norm;V.y=V.y*V_norm;V.z=V.z*V_norm;
                double mv=acos(fabs(U.x*V.x+U.y*V.y+U.z*V.z));
		double d3,d4;
		struct Point M1;
            	M1.x=(P1.x+Q1.x)*0.5;M1.y=(P1.y+Q1.y)*0.5;M1.z=(P1.z+Q1.z)*0.5;
		double c1=-(V.x*M1.x+V.y*M1.y+V.z*M1.z);
		d3=fabs(V.x*P.x+V.y*P.y+V.z*P.z+c1);
		d4=fabs(V.x*Q.x+V.y*Q.y+V.z*Q.z+c1);
                if (d1!=0 && d2!=0 && d3!=0&&d4!=0&& min1(d1,d2)/max1(d1,d2)>=1-0.001 && min1(d1,d2)/max1(d1,d2)>=1-0.001 && mv<=th_t)
                {
                    int indx=cnt_g*6;
                    loc_P1[indx+0]=P.x;
                    loc_P1[indx+1]=P.y;
                    loc_P1[indx+2]=P.z;
                    loc_P1[indx+3]=Q.x;
                    loc_P1[indx+4]=Q.y;
                    loc_P1[indx+5]=Q.z;
                    loc_P2[indx+0]=P1.x;
                    loc_P2[indx+1]=P1.y;
                    loc_P2[indx+2]=P1.z;
                    loc_P2[indx+3]=Q1.x;
                    loc_P2[indx+4]=Q1.y;
                    loc_P2[indx+5]=Q1.z;
                    cnt_g=cnt_g+1;
                    double *tmp_P1=realloc(loc_P1, 6*(cnt_g+1)*sizeof(double));
                    loc_P1=tmp_P1;
                    double *tmp_P2=realloc(loc_P2, 6*(cnt_g+1)*sizeof(double));
                    loc_P2=tmp_P2;            
                }
            }
        }
    }
    
    pt1_OUT=mxCreateDoubleMatrix(6*(cnt_g+1)-6,1,mxREAL);
    pt2_OUT=mxCreateDoubleMatrix(6*(cnt_g+1)-6,1,mxREAL);
    pt1=mxGetPr(pt1_OUT);
    pt2=mxGetPr(pt2_OUT);
    for(pr=0;pr<6*(cnt_g+1)-6;pr++)
    {
        pt1[pr]=loc_P1[pr];
        pt2[pr]=loc_P2[pr];
    }
    free(loc_P1);
    free(loc_P2);
    return;
}
